import sys, os
import csv, itertools

class Restaurant(object):
    def __init__(self, ID, items):
        self.ID = ID
        # Create a set of all items for easy satisfaction querying.
        self.Menu = set()
        for item in items:
            self.Menu |= set(item['items'])

    def satisfies(self, desired):
        return self.Menu >= set(desired)

    def get_best_price(self, desired):
        # The behavior of this when satifies(desired) is False is undefined.
        pass

    def get_combinations(self, restaurant, desired):
        # Generate the different ways a restaurant could provide the desired.
        pass


    def __cmp__(self, other):
        return cmp(self.ID, other.ID)

def main(csv_data, items):
    restaurants = None

def get_restaurants(csv_data):
    # Group the items by restaurant ID.
    restaurant_data = itertools.groupby(csv_data, lambda x: x['id'])
    # Create restaurant objects.
    restaurants = [Restaurant(rest_id, list(group)) for rest_id, group in restaurant_data]
    return restaurants

def load_csv(csv_path):
    # We could check if the file exists but the exception in this case is straightforward.
    csv_descriptor = open(csv_path, 'rb')
    reader = csv.reader(csv_descriptor)
    rows = []
    for row in reader:
        rest_id = row[0].strip()
        price = float(row[1].strip())
        items = [item.strip() for item in row[2:]]
        rows.append({'id': rest_id, 'price': price, 'items': items})
    return rows
    
def parse_args():
    # Get the args, chopping off the script which doesn't concern us.
    args = sys.argv[1:]
    if len(args) < 2:
        print "USAGE: %s data.csv item_1 [item_2, item_3]" % os.path.split(__file__)[-1]
        sys.exit(1)
    return args[0], args[1:]

if __name__ == "__main__":
    csv_path, items = parse_args()
    csv_data = load_csv(csv_path)
    main(csv_data, items)
