import unittest
import main

class JurgensvilleTests(unittest.TestCase):
    def getRestaurants(self):
        return main.get_restaurants(main.load_csv('sample_data.csv'))

    def testCSVLoading(self):
        data = main.load_csv('sample_data.csv')
        # Assert we get the expected number of rows.
        self.assertEquals(len(data), 12)
        # Assert the structure and typing of the rows via the first row.
        self.assertEquals(data[0], {'id': '1', 'price': 4.0, 'items': ['burger']})

    def testGetResaurants(self):
        restaurants = self.getRestaurants()
        self.assertEquals(len(restaurants), 6)

    def testRestaurantMatching_Negative(self):
        first = sorted(self.getRestaurants())[0]
        self.assertEquals(first.ID, '1')
        self.assertFalse(first.satisfies(['chef_salad']))

    def testRestaurantMatching_Positive(self):
        first = sorted(self.getRestaurants())[0]
        self.assertEquals(first.ID, '1')
        self.assertTrue(first.satisfies(['burger']))

if __name__ == "__main__":
    unittest.main()

